  MEMBER

  PRAGMA('project(#pragma link(C60HTMX.LIB))')
  PRAGMA('project(#pragma link(WIN32.LIB))')
  PRAGMA('project(#pragma link(qrcodelib.lib))')

  PRAGMA('project(#compile libcurl.clw)')
  PRAGMA('project(#pragma link(libcurl.lib))')
  INCLUDE('cJSON.inc')
  INCLUDE('Windows.inc')
  INCLUDE('base64.inc')

  INCLUDE('sbpqrclass.inc')

  MAP
    MODULE('WINAPI')
      qr_lstrcpy(*CSTRING inStr,LONG inAddrFrom),LONG,PASCAL,RAW,NAME('lstrcpy'),PROC
      qr_GetTempPath(LONG nBufferLength, *CSTRING lpBuffer),SIGNED,PASCAL,RAW,PROC,NAME('GetTempPathA')
    END
    MODULE('qrcodelib.lib')
      FastQRCode(LONG pText, LONG pFileName),LONG,RAW,PASCAL
    END
  END

URL_OAUTH                     EQUATE('https://api.sberbank.ru:8443/prod/tokens/v2/oauth')
URL_ORDER_CREATE              EQUATE('https://api.sberbank.ru:8443/prod/qr/order/v3/creation')
URL_ORDER_REVOKE              EQUATE('https://api.sberbank.ru:8443/prod/qr/order/v3/revocation')
URL_ORDER_REGISTRY            EQUATE('https://api.sberbank.ru:8443/prod/qr/order/v3/registry')
URL_ORDER_STATUS              EQUATE('https://api.sberbank.ru:8443/prod/qr/order/v3/status')

TokenGroup                    GROUP,TYPE
expires_in                      LONG
token_type                      CSTRING(256)
session_state                   CSTRING(256)
access_token                    CSTRING(256) !      
scope                           CSTRING(256)
                              END

OrderStatusGroup              GROUP,TYPE
rq_uid                          STRING(32)   !   
rq_tm                           STRING(20)   ! /  , example: "2005-08-15T15:52:01Z"
order_id                        STRING(36)   ! ID    .
tid                             STRING(36)   !   
partner_order_number            STRING(36)   !    CRM 
                              END

OrderRevokeGroup              GROUP,TYPE
rq_uid                          STRING(32)   !   
rq_tm                           STRING(20)   ! /  , example: "2005-08-15T15:52:01Z"
order_id                        STRING(36)   ! ID    .
                              END

OrderRevokeResultGroup        GROUP,TYPE
rq_uid                          STRING(32)   !   
rq_tm                           STRING(20)   ! /  , example: "2005-08-15T15:52:01Z"
order_id                        STRING(36)   ! ID    .
order_state                     STRING(20)   !   "PAID", "CREATED", "REVERSED", "REFUNDED", "REVOKED", "DECLINED", "EXPIRED", "AUTHORIZED", "CONFIRMED", "ON_PAYMENT
error_code                      STRING(6)    !   
error_description               STRING(1024) !    
                              END

OrderRegistryGroup            GROUP,TYPE
rqUid                           STRING(32),NAME('rqUid')        !   
rqTm                            STRING(20),NAME('rqTm')         ! /  , example: "2005-08-15T15:52:01Z"
idQR                            STRING(36),NAME('idQR')         ! IdQR ,    
startPeriod                     STRING(20),NAME('startPeriod')  ! /  :       ( Ecom)  .
endPeriod                       STRING(20),NAME('endPeriod')    ! /  :       ( Ecom)  .
registryType                    STRING(20),NAME('registryType') !  .  : QUANTITY/REGISTRY.
                              END         
                                      
OrderRegistryResultGroup      GROUP,TYPE
rqUid                           STRING(32),NAME('rqUid')                   !   
rqTm                            STRING(20),NAME('rqTm')                    ! /  , example: "2005-08-15T15:52:01Z"
idQR                            STRING(36),NAME('idQR')                    ! IdQR ,    
tid                             STRING(8),NAME('tid')                      !   
errorCode                       STRING(6),NAME('errorCode')                !   
errorDescription                STRING(1024),NAME('errorDescription')      !    
quantityData                    GROUP,NAME('quantityData')                 !   ,    RegistryType = QUANTITY
totalCount                        DECIMAL(10),NAME('totalCount')           !  -  
totalPaymentAmount                DECIMAL(15,2),NAME('totalPaymentAmount') !   :       ( ).
totalRefundAmount                 DECIMAL(15,2),NAME('totalRefundAmount')  !         
totalAmount                       DECIMAL(15,2),NAME('totalAmount')        !   :             ( )
                                END
!registryData                    &RegistryData                              !   ,    RegistryType = REGISTRY
                              END
                                      
OrderCreateGroup              GROUP,TYPE
rq_uid                          STRING(32)   !   
rq_tm                           STRING(20)   ! /  , example: "2005-08-15T15:52:01Z"
member_id                       STRING(8)    !  
order_number                    STRING(36)   !    CRM 
order_create_date               STRING(20)   ! /  , example: "2005-08-15T15:52:01Z"
order_params_type               &OrderCreateDetailQueue !  
id_qr                           STRING(36)   ! IdQR ,    
order_sum                       DECIMAL(15,2)!      , 15  = 1500
currency                        STRING(3)    ! ,  = 810
description                     STRING(256)  !  
sbp_member_id                   STRING(12)   !  SBP_MEMBER_ID,  
                              END

OrderResultGroup              GROUP,TYPE
rq_uid                          STRING(32)   !   
rq_tm                           STRING(20)   ! /  , example: "2005-08-15T15:52:01Z"
order_number                    STRING(36)   !    CRM 
order_id                        STRING(36)   ! ID    .
order_state                     STRING(20)   !   "PAID", "CREATED", "REVERSED", "REFUNDED", "REVOKED", "DECLINED", "EXPIRED", "AUTHORIZED", "CONFIRMED", "ON_PAYMENT
order_form_url                  STRING(256)  !    QR code
error_code                      STRING(6)    !   
error_description               STRING(1024) !    
                              END

SbpQRClass.Construct          PROCEDURE
  CODE
  SELF.curl &= NEW TStrCurlClass
  SELF.buffer &= NEW BufferClass
  SELF.curl.Init()

SbpQRClass.Destruct           PROCEDURE
  CODE
  DISPOSE(SELF.curl)

SbpQRClass.Init               PROCEDURE(STRING MemberID, STRING IDQr, STRING clientID, |
                                        STRING clientSecret, STRING CertFile, STRING CertType, |
                                        STRING CertPass)
  CODE
  SELF.MemberID = MemberID           !   8 
  SELF.IDQr = IDQr                   !   .    
  SELF.clientID = clientID           !    
  SELF.clientSecret = clientSecret   !    
  SELF.CertFile = CertFile           !  
  SELF.CertType = CertType           !   ( )
  SELF.CertPass = CertPass           !  
  SELF.SetTimeOut()
                                                                                 
SbpQRClass.SetTimeOffset      PROCEDURE(LONG TimeOffset)
  CODE                
  IF ABS(TimeOffset) > 24 
    SELF.Message('      24 ')
    RETURN
  END
  SELF.TimeOffset = TimeOffset * 360000
  
SbpQRClass.GetToken           PROCEDURE(STRING Scope)!,LONG,PRIVATE
result                        CURLcode
AuthorisationData             BufferClass
PostFields                    BufferClass
ResultBuffer                  BufferClass

json                          cJSONFactory
root                          &cJson
tg                            LIKE(TokenGroup)
  CODE
  SELF.Token = ''
  AuthorisationData.Set(SELF.Base64Encode(CLIP(SELF.clientID)&':'&CLIP(SELF.clientSecret)))

  SELF.curl.FreeHttpHeaders()
  SELF.curl.AddHttpHeader('authorization: Basic ' & AuthorisationData.CStr())
  SELF.curl.AddHttpHeader('accept: application/json')
  SELF.curl.AddHttpHeader('content-type: application/x-www-form-urlencoded')
  SELF.curl.AddHttpHeader('rquid: ' & CLIP(SELF.GetRquid()))
  SELF.curl.AddHttpHeader('x-ibm-client-id: ' & CLIP(SELF.clientID))
  PostFields.Set('grant_type=client_credentials&scope='&Scope)

  SELF.curl.SetHttpHeaders()

  SELF.curl.SetOpt(CURLOPT_SSLCERT, SELF.CertFile)
  SELF.curl.SetOpt(CURLOPT_SSLCERTTYPE, SELF.CertType)
  SELF.curl.SetOpt(CURLOPT_KEYPASSWD, SELF.CertPass)

  SELF.curl.SetCustomRequest('POST')

  SELF.curl.SetSSLVerifyHost(0)
  SELF.curl.SetSSLVerifyPeer(0)
  SELF.curl.SetSSLVersion('')
  SELF.curl.SetCAInfo('')

  result = SELF.curl.SendRequest(URL_OAUTH, PostFields.CStr(), ResultBuffer)
  ResultBuffer.ToASCII()
  ResultBuffer.SaveToFile('~GetToken_result.json')

  IF NOT result = CURLE_OK
    SELF.Message('   : '& SELF.curl.StrError(result))
    RETURN result
  END

  IF SELF.CheckServerError(ResultBuffer)
    SELF.Message('   :<13,10>'&SELF.GetServerError())
    RETURN 99
  END

  IF SELF.CheckAPIError(ResultBuffer)
    SELF.Message('   :<13,10>'&SELF.GetAPIError())
    RETURN 99
  END

  root &= json.Parse(ResultBuffer.Str())
  IF NOT root &= NULL
    IF root.ToGroup(tg)
      SELF.Token = tg.access_token
    ELSE
      SELF.Message('    !')
      root.Delete()
      RETURN 99
    END
    root.Delete()
  END
  RETURN result

SbpQRClass.OrderCreate        PROCEDURE(*OrderCreateParamGroup ocp, *OrderCreateDetailGroup ocdg)!,LONG
ocdg_as_queue                 QUEUE(OrderCreateDetailQueue).
  CODE
  ocdg_as_queue :=: ocdg
  ADD(ocdg_as_queue)
  RETURN SELF.OrderCreate(ocp, ocdg_as_queue)

SbpQRClass.OrderCreate        PROCEDURE(*OrderCreateParamGroup ocp, *OrderCreateDetailQueue ocdq)!,LONG
l:c                           LONG
result                        CURLcode
rquid                         STRING(32)
json                          cJSONFactory
root                          &cJson
params                        &cJson
details                       &cJson
oc                            LIKE(OrderCreateGroup)
ocd                           QUEUE(OrderCreateDetailQueue).
ores                          LIKE(OrderResultGroup)
ResultBuffer                  BufferClass
  CODE
  rquid = SELF.GetRquid()

  SELF.curl.FreeHttpHeaders()
  SELF.curl.AddHttpHeader('authorization: Bearer ' & CLIP(SELF.Token))
  SELF.curl.AddHttpHeader('accept: application/json')
  SELF.curl.AddHttpHeader('content-type: application/json')
  SELF.curl.AddHttpHeader('rquid: ' & CLIP(rquid))
  SELF.curl.AddHttpHeader('x-introspect-rquid: ' & CLIP(SELF.GetRquid()))
  SELF.curl.AddHttpHeader('x-ibm-client-id: ' & CLIP(SELF.clientID))
  SELF.curl.SetHttpHeaders()

  !  
  oc.rq_uid            = rquid
  oc.rq_tm             = SELF.FormatDate()
  oc.member_id         = SELF.MemberID
  oc.order_number      = ocp.order_number
  oc.order_create_date = SELF.FormatDate(ocp.order_create_date, ocp.order_create_time)
  oc.id_qr             = SELF.IDQr
  oc.order_sum         = ocp.order_sum * 100
  oc.currency          = ocp.currency
  oc.description       = ocp.description
  oc.sbp_member_id     = SBP_MEMBER_ID
  params &= json::CreateObject(oc)

  LOOP l:c = 1 TO RECORDS(ocdq)
    GET(ocdq, l:c)
    ocd :=: ocdq
    ocd.position_sum   = ocdq.position_sum * 100
    ADD(ocd)
  END
  details &= json::CreateArray(ocd)
  FREE(ocd)

  params.ReplaceItemInObject('order_params_type', details)

  SELF.SaveToFile(params.ToString(TRUE), '~OrderCreate_request.json')

  result = SELF.curl.SendRequest(URL_ORDER_CREATE, SELF.ToUTF8(params.ToString()), ResultBuffer)
  ResultBuffer.ToASCII()
  params.Delete()

  ResultBuffer.SaveToFile('~OrderCreate_result.json')

  IF NOT result = CURLE_OK
    SELF.Message('   : '& SELF.curl.StrError(result))
    RETURN result
  END

  IF SELF.CheckServerError(ResultBuffer)
    SELF.Message('   :<13,10>'&SELF.GetServerError())
    RETURN 99
  END

  IF SELF.CheckAPIError(ResultBuffer)
    SELF.Message('   :<13,10>'&SELF.GetAPIError())
    RETURN 99
  END

  root &= json.Parse(ResultBuffer.Str())
  IF NOT root &= NULL
    IF root.ToGroup(ores) AND ores.error_code = 0
      ocp.order_id = ores.order_id
      ocp.order_state = ores.order_state
      ocp.order_form_url = ores.order_form_url
    ELSE
      SELF.buffer.Set('  !')
      SELF.buffer.Cat('<13,10>rq_uid: ' & ores.rq_uid)
      SELF.buffer.Cat('<13,10>order_state: ' & ores.order_state)
      SELF.buffer.Cat('<13,10>'&ALL('-',20))
      SELF.buffer.Cat('<13,10>error_code: ' & ores.error_code)
      SELF.buffer.Cat('<13,10>error_description ' & ores.error_description)
      SELF.Message(SELF.buffer.Str())
      result = 99
    END
    root.Delete()
  END
  RETURN result

SbpQRClass.OrderRegistry      PROCEDURE(*OrderRegistryParamGroup org)!,LONG
result                        CURLcode
rquid                         STRING(32)
json                          cJSONFactory
root                          &cJson
params                        &cJson
orp                           LIKE(OrderRegistryGroup)
ores                          LIKE(OrderRegistryResultGroup)
ResultBuffer                  BufferClass
  CODE
  rquid = SELF.GetRquid()

  SELF.curl.FreeHttpHeaders()
  SELF.curl.AddHttpHeader('authorization: Bearer ' & CLIP(SELF.Token))
  SELF.curl.AddHttpHeader('accept: application/json')
  SELF.curl.AddHttpHeader('content-type: application/json')          
  SELF.curl.AddHttpHeader('rquid: ' & CLIP(rquid))
  SELF.curl.AddHttpHeader('x-introspect-rquid: ' & CLIP(SELF.GetRquid()))
  SELF.curl.AddHttpHeader('x-ibm-client-id: ' & CLIP(SELF.clientID))
  SELF.curl.SetHttpHeaders()

  !  
  orp.rqUid            = rquid
  orp.rqTm             = SELF.FormatDate()
  orp.idQR             = SELF.IDQr
  orp.startPeriod      = SELF.FormatDate(org.startPeriod, 0, TRUE)
  orp.endPeriod        = SELF.FormatDate(org.endPeriod, 0, TRUE)
  orp.registryType     = org.registryType

  params &= json::CreateObject(orp,FALSE)

  SELF.SaveToFile(params.ToString(TRUE), '~Registry_request.json')

  result = SELF.curl.SendRequest(URL_ORDER_REGISTRY, SELF.ToUTF8(params.ToString()), ResultBuffer)
  ResultBuffer.ToASCII()
  params.Delete()

  ResultBuffer.SaveToFile('~Registry_result.json')

  IF NOT result = CURLE_OK
    SELF.Message('   : '& SELF.curl.StrError(result))
    RETURN result
  END

  IF SELF.CheckServerError(ResultBuffer)
    SELF.Message('   :<13,10>'&SELF.GetServerError())
    RETURN 99
  END

  IF SELF.CheckAPIError(ResultBuffer)
    SELF.Message('   :<13,10>'&SELF.GetAPIError())
    RETURN 99
  END

  root &= json.Parse(ResultBuffer.Str())
  IF NOT root &= NULL
    IF root.ToGroup(ores) AND ores.errorCode = 0
    ELSE
      SELF.buffer.Set('  !')
      SELF.buffer.Cat('<13,10>rq_uid: ' & ores.rqUid)
      SELF.buffer.Cat('<13,10>'&ALL('-',20))
      SELF.buffer.Cat('<13,10>error_code: ' & ores.errorCode)
      SELF.buffer.Cat('<13,10>error_description ' & ores.errorDescription)
      SELF.Message(SELF.buffer.Str())
      result = 99
    END
    root.Delete()
  END
  RETURN result

SbpQRClass.OrderRevoke        PROCEDURE(*OrderRevokeParamGroup org)!,LONG
result                        CURLcode
rquid                         STRING(32)
json                          cJSONFactory
root                          &cJson
params                        &cJson
orp                           LIKE(OrderRevokeGroup)
ores                          LIKE(OrderRevokeResultGroup)
ResultBuffer                  BufferClass
  CODE
  rquid = SELF.GetRquid()

  SELF.curl.FreeHttpHeaders()
  SELF.curl.AddHttpHeader('authorization: Bearer ' & CLIP(SELF.Token))
  SELF.curl.AddHttpHeader('accept: application/json')
  SELF.curl.AddHttpHeader('content-type: application/json')
  SELF.curl.AddHttpHeader('rquid: ' & CLIP(rquid))
  SELF.curl.AddHttpHeader('x-introspect-rquid: ' & CLIP(SELF.GetRquid()))
  SELF.curl.AddHttpHeader('x-ibm-client-id: ' & CLIP(SELF.clientID))
  SELF.curl.SetHttpHeaders()

  !  
  orp.rq_uid           = rquid
  orp.rq_tm            = SELF.FormatDate()
  orp.order_id         = org.order_id

  params &= json::CreateObject(orp)

  SELF.SaveToFile(params.ToString(TRUE), '~Revoke_request.json')

  result = SELF.curl.SendRequest(URL_ORDER_REVOKE, SELF.ToUTF8(params.ToString()), ResultBuffer)
  ResultBuffer.ToASCII()
  params.Delete()

  ResultBuffer.SaveToFile('~Revoke_result.json')

  IF NOT result = CURLE_OK
    SELF.Message('   : '& SELF.curl.StrError(result))
    RETURN result
  END

  IF SELF.CheckServerError(ResultBuffer)
    SELF.Message('   :<13,10>'&SELF.GetServerError())
    RETURN 99
  END

  IF SELF.CheckAPIError(ResultBuffer)
    SELF.Message('   :<13,10>'&SELF.GetAPIError())
    RETURN 99
  END

  root &= json.Parse(ResultBuffer.Str())
  IF NOT root &= NULL
    IF root.ToGroup(ores) AND ores.error_code = 0
      org.order_state = ores.order_state
    ELSE
      SELF.buffer.Set('  !')
      SELF.buffer.Cat('<13,10>rq_uid: ' & ores.rq_uid)
      SELF.buffer.Cat('<13,10>order_state: ' & ores.order_state)
      SELF.buffer.Cat('<13,10>'&ALL('-',20))
      SELF.buffer.Cat('<13,10>error_code: ' & ores.error_code)
      SELF.buffer.Cat('<13,10>error_description ' & ores.error_description)
      SELF.Message(SELF.buffer.Str())
      result = 99
    END
    root.Delete()
  END
  RETURN result

SbpQRClass.OrderStatus        PROCEDURE(*OrderStatusParamGroup org)!,LONG
result                        CURLcode
rquid                         STRING(32)
json                          cJSONFactory
root                          &cJson
params                        &cJson
orp                           LIKE(OrderStatusGroup)
!ores                          LIKE(OrderRevokeResultGroup)
ResultBuffer                  BufferClass
  CODE
  rquid = SELF.GetRquid()

  SELF.curl.FreeHttpHeaders()
  SELF.curl.AddHttpHeader('authorization: Bearer ' & CLIP(SELF.Token))
  SELF.curl.AddHttpHeader('accept: application/json')
  SELF.curl.AddHttpHeader('content-type: application/json')
  SELF.curl.AddHttpHeader('rquid: ' & CLIP(rquid))
  SELF.curl.AddHttpHeader('x-introspect-rquid: ' & CLIP(SELF.GetRquid()))
  SELF.curl.AddHttpHeader('x-ibm-client-id: ' & CLIP(SELF.clientID))
  SELF.curl.SetHttpHeaders()

  !  
  orp.rq_uid               = rquid
  orp.rq_tm                = SELF.FormatDate()
  orp.order_id             = org.order_id
  orp.tid                  = SELF.IDQr
  orp.partner_order_number = org.partner_order_number

  params &= json::CreateObject(orp)

  SELF.SaveToFile(params.ToString(TRUE), '~Status_request.json')

  result = SELF.curl.SendRequest(URL_ORDER_STATUS, SELF.ToUTF8(params.ToString()), ResultBuffer)
  ResultBuffer.ToASCII()
  params.Delete()

  ResultBuffer.SaveToFile('~Status_result.json')

  IF NOT result = CURLE_OK
    SELF.Message('    : '& SELF.curl.StrError(result))
    RETURN result
  END

  IF SELF.CheckServerError(ResultBuffer)
    SELF.Message('    :<13,10>'&SELF.GetServerError())
    RETURN 99
  END

  IF SELF.CheckAPIError(ResultBuffer)
    SELF.Message('    :<13,10>'&SELF.GetAPIError())
    RETURN 99
  END

!  root &= json.Parse(ResultBuffer.Str())
!  IF NOT root &= NULL
!    IF root.ToGroup(ores) AND ores.error_code = 0
!      org.order_state = ores.order_state
!    ELSE
!      SELF.buffer.Set('  !')
!      SELF.buffer.Cat('<13,10>rq_uid: ' & ores.rq_uid)
!      SELF.buffer.Cat('<13,10>order_state: ' & ores.order_state)
!      SELF.buffer.Cat('<13,10>'&ALL('-',20))
!      SELF.buffer.Cat('<13,10>error_code: ' & ores.error_code)
!      SELF.buffer.Cat('<13,10>error_description ' & ores.error_description)
!      SELF.Message(SELF.buffer.Str())
!      result = 99
!    END
!    root.Delete()
!  END
  RETURN result

SbpQRClass.CheckAPIError      PROCEDURE(BufferClass pCStr)!,BYTE
json                          cJSONFactory
root                          &cJson
  CODE
  CLEAR(SELF.APIError)
  root &= json.Parse(pCStr.Str())
  IF NOT root &= NULL
    IF root.ToGroup(SELF.APIError)
      IF SELF.APIError.httpCode
        root.Delete()
        RETURN TRUE
      END
    ELSE
      CLEAR(SELF.APIError)
    END
    root.Delete()
  END
  RETURN FALSE

SbpQRClass.GetAPIError        PROCEDURE()!,STRING
temp                          BufferClass
  CODE
  IF SELF.APIError.httpCode
    temp.Cat('httpCode: ' & CLIP(SELF.APIError.httpCode))
    temp.Cat('<13,10>httpMessage: ' & CLIP(SELF.APIError.httpMessage))
    temp.Cat('<13,10>moreInformation: ' & CLIP(SELF.APIError.moreInformation))
  END
  RETURN temp.CStr()

SbpQRClass.CheckServerError   PROCEDURE(BufferClass pCStr)!,BYTE
json                          cJSONFactory
root                          &cJson
  CODE
  CLEAR(SELF.ServerError)
  root &= json.Parse(pCStr.Str())
  IF NOT root &= NULL
    IF root.ToGroup(SELF.ServerError)
      IF SELF.ServerError.status
        root.Delete()
        RETURN TRUE
      END
    ELSE
      CLEAR(SELF.ServerError)
    END
    root.Delete()
  END
  RETURN FALSE

SbpQRClass.GetServerError     PROCEDURE()!,STRING
temp                          BufferClass
  CODE
  IF SELF.ServerError.status
    temp.Cat('status: ' & CLIP(SELF.ServerError.status))
    temp.Cat('<13,10>error: ' & CLIP(SELF.ServerError.error))
    temp.Cat('<13,10>message ' & CLIP(SELF.ServerError.message))
    temp.Cat('<13,10>path ' & CLIP(SELF.ServerError.path))
  END
  RETURN temp.CStr()

SbpQRClass.SetTimeOut         PROCEDURE(LONG inTimeOut=5)
  CODE
  SELF.TimeOut = inTimeOut
  SELF.curl.SetOpt(CURLOPT_CONNECTTIMEOUT, SELF.TimeOut)

SbpQRClass.GetGUID            PROCEDURE()!,STRING
localUUID                     LIKE(UUID)
uuidStrptr                    LONG(0)
tempcstr                      CSTRING(80)
  CODE
  UUIDCreate(localUUID)
  UuidToString(localUUID, uuidStrptr)
  qr_lstrcpy(tempcstr, uuidStrptr)
  RpcStringFree(uuidStrptr)
  RETURN tempcstr

SbpQRClass.GetRquid           PROCEDURE()!,STRING
lguid                         STRING(36)
  CODE
  lguid = SELF.GetGUID()
  RETURN SUB(lguid,1,8)&SUB(lguid,10,4)&SUB(lguid,15,4)&SUB(lguid,20,4)&SUB(lguid,25,12)

SbpQRClass.Base64Encode       PROCEDURE(STRING inStr)!,STRING
BufferCStr                    BufferClass
BufferSize                    ULONG
  CODE
  BufferCStr.Empty(SIZE(inStr)*2+1)
  BufferSize = BufferCStr.Len
  ret# = base64_encode(BufferCStr.S, BufferSize, inStr, SIZE(inStr))
  IF ret# = ERR_BASE64_BUFFER_TOO_SMALL
    BufferCStr.Empty(SIZE(inStr)*2+2)
    BufferSize = BufferCStr.Len
    ret# = base64_encode(BufferCStr.S, BufferSize, inStr, SIZE(inStr))
  END
  RETURN BufferCStr.Str()

SbpQRClass.Message            PROCEDURE(STRING inMessage)
  CODE
  MESSAGE(inMessage, '  QR ', ICON:Asterisk)

SbpQRClass.FormatDate         PROCEDURE(<LONG inDate>, <LONG inTime>, BYTE TimeOffset=FALSE)!, STRING
newtime                       LONG
  CODE
  IF OMITTED(inDate) THEN inDate = TODAY() END
  IF OMITTED(inTime) THEN inTime = CLOCK() END
  IF TimeOffset   
    inTime += SELF.TimeOffset
    IF SELF.TimeOffset > 0
      IF inTime > 360000*24
        inTime -= 360000*24
        inDate += 1
      END  
    ELSE
      IF inTime  < 0 
        inTime = 360000*24 - ABS(inTime)
        inDate -= 1
      END  
    END
  END
  ! example: "2005-08-15T15:52:01Z"
  RETURN FORMAT(inDate,@D10-)&'T'&FORMAT(inTime,@T04)&'Z'

SbpQRClass.SaveToFile         PROCEDURE(STRING inStr, STRING inFile)
temp                          BufferClass
  CODE
  temp.Cat(inStr)
  temp.SaveToFile(inFile)

SbpQRClass.ToUTF8             PROCEDURE(STRING inStr)!, STRING
temp                          BufferClass
  CODE
  temp.Set(inStr)
  temp.ToUTF8()
  RETURN temp.Str()
  
SbpQRClass.GetQRImageFile     PROCEDURE(STRING inUrl, <STRING inPath>)!, STRING      
LOC:ImageFile                 CSTRING(256)  
  CODE
  IF OMITTED(3)
    qr_GetTempPath(SIZE(LOC:ImageFile), LOC:ImageFile)
  ELSE
    LOC:ImageFile = inPath
  END
  LOOP 10 TIMES
    LOC:ImageFile = CLIP(LOC:ImageFile)&CHR(RANDOM(97,122))
  END                                   
  LOC:ImageFile = CLIP(LOC:ImageFile)&'.bmp'
  Err# = FastQRCode(ADDRESS(inUrl),ADDRESS(LOC:ImageFile))
  RETURN LOC:ImageFile

TStrCurlClass.SendRequest     PROCEDURE(STRING pUrl, <STRING pPostFields>, BufferClass pCStr, <curl::ProgressDataProcType xferproc>)!, CURLcode, PROC
tempBuffer                    &IDynStr
result                        CURLcode
  CODE
  tempBuffer &= NewDynStr()
  result = SELF.SendRequest(pUrl, pPostFields, tempBuffer, xferproc)
  pCStr.Cat(tempBuffer.CStr())
  DisposeDynStr(tempBuffer)
  RETURN result
