OMIT('_EndOfInclude_',_sbpqrclassPresent_)
_sbpqrclassPresent_ EQUATE(1)
                                        
  INCLUDE('Cstr.inc')
  INCLUDE('libcurl.inc')

SBP_SCOPES                    EQUATE('https://api.sberbank.ru/qr/order.create https://api.sberbank.ru/qr/order.revoke https://api.sberbank.ru/qr/order.status auth://qr/order.registry')

SBP_MEMBER_ID                 EQUATE('100000000111') !  - " "  
SBP_ROUBLE                    EQUATE(643)

!  
SBP_OS_PAID                   EQUATE('PAID')
SBP_OS_CREATED                EQUATE('CREATED')
SBP_OS_REVERSED               EQUATE('REVERSED')
SBP_OS_REFUNDED               EQUATE('REFUNDED')
SBP_OS_REVOKED                EQUATE('REVOKED ')
SBP_OS_DECLINED               EQUATE('DECLINED')
SBP_OS_EXPIRED                EQUATE('EXPIRED')
SBP_OS_AUTHORIZED             EQUATE('AUTHORIZED')
SBP_OS_CONFIRMED              EQUATE('CONFIRMED')
SBP_OS_ON_PAYMENT             EQUATE('ON_PAYMENT')

!  
SBP_RG_QUANTITY               EQUATE('QUANTITY')
SBP_RG_REGISTRY               EQUATE('REGISTRY')

OrderCreateParamGroup         GROUP,TYPE
! 
order_number                    STRING(36)   !    CRM 
order_create_date               LONG         !   
order_create_time               LONG         !   
order_sum                       DECIMAL(15,2)!      , 15  = 1500
currency                        SHORT        ! ,  = 810
description                     STRING(256)  !  
! 
order_id                        STRING(36)   ! ID    .
order_state                     STRING(20)   !   "PAID", "CREATED", "REVERSED", "REFUNDED", "REVOKED", "DECLINED", "EXPIRED", "AUTHORIZED", "CONFIRMED", "ON_PAYMENT
order_form_url                  STRING(256)  !    QR code
                              END

OrderCreateDetailGroup        GROUP,TYPE
position_name                   STRING(256)  !   
position_count                  DECIMAL(6)   !    
position_sum                    DECIMAL(15,2)!       
position_description            STRING(1024) !   
                              END

OrderCreateDetailQueue        QUEUE(OrderCreateDetailGroup),TYPE
                              END

OrderRegistryParamGroup       GROUP,TYPE 
! 
startPeriod                     LONG          ! /  :       ( Ecom)  .
endPeriod                       LONG          ! /  :       ( Ecom)  .
registryType                    STRING(20)    !  .  : QUANTITY/REGISTRY.
! 
!registryData                    &RegistryData !   
                              END
                              
RegistryData                  QUEUE,TYPE
                              END            

OrderRevokeParamGroup         GROUP,TYPE
! 
order_id                        STRING(36)   ! ID    .
! 
order_state                     STRING(20)   !   "PAID", "CREATED", "REVERSED", "REFUNDED", "REVOKED", "DECLINED", "EXPIRED", "AUTHORIZED", "CONFIRMED", "ON_PAYMENT
! ?????????????????????????????
                              END

OrderStatusParamGroup         GROUP,TYPE
! 
order_id                        STRING(36)   ! ID    .
partner_order_number            STRING(36)   !    CRM 
! 
order_state                     STRING(20)   !   "PAID", "CREATED", "REVERSED", "REFUNDED", "REVOKED", "DECLINED", "EXPIRED", "AUTHORIZED", "CONFIRMED", "ON_PAYMENT
                              END
                                               
SbpAPIErrorGroup              GROUP,TYPE
httpCode                        STRING(256)
httpMessage                     STRING(256)
moreInformation                 STRING(256)
                              END

SbpServerErrorGroup           GROUP,TYPE
timestamp                       STRING(256)
status                          LONG
error                           STRING(256)
message                         STRING(256)
path                            STRING(256)
                              END
                                 
BufferClass                   CLASS(CStr),TYPE,MODULE('sbpqrclass.clw'),LINK('sbpqrclass.clw',_ClassesLinkMode_),DLL(_ClassesDllMode_)
                              END

TStrCurlClass                 CLASS(TCurlClass),TYPE,MODULE('sbpqrclass.clw'),LINK('sbpqrclass.clw',_ClassesLinkMode_),DLL(_ClassesDllMode_)
SendRequest                     PROCEDURE(STRING pUrl, <STRING pPostFields>, BufferClass pCStr, <curl::ProgressDataProcType xferproc>), CURLcode, PROC
                              END

SbpQRClass                    CLASS,TYPE,MODULE('sbpqrclass.clw'),LINK('sbpqrclass.clw',_ClassesLinkMode_),DLL(_ClassesDllMode_)
buffer                          &BufferClass
curl                            &TStrCurlClass
APIError                        LIKE(SbpAPIErrorGroup)
ServerError                     LIKE(SbpServerErrorGroup)

clientID                        STRING(100)
clientSecret                    STRING(100)
CertFile                        STRING(256)
CertType                        STRING(20)
CertPass                        STRING(20)
MemberID                        STRING(8)
IDQr                            STRING(100)

TimeOut                         LONG
Token                           STRING(100)              
TimeOffset                      LONG(0)

Construct                       PROCEDURE
Destruct                        PROCEDURE
Init                            PROCEDURE(STRING MemberID, STRING IDQr, STRING clientID, |
                                          STRING clientSecret, STRING CertFile, STRING CertType, |
                                          STRING CertPass)        
!      ,                                           
SetTimeOffset                   PROCEDURE(LONG TimeOffset)                       
GetToken                        PROCEDURE(STRING Scope),LONG
!  
OrderCreate                     PROCEDURE(*OrderCreateParamGroup ocp, *OrderCreateDetailGroup ocdg),LONG
OrderCreate                     PROCEDURE(*OrderCreateParamGroup ocp, *OrderCreateDetailQueue ocdq),LONG
!   
OrderRegistry                   PROCEDURE(*OrderRegistryParamGroup org),LONG
!   /  
!OrderCancel                     PROCEDURE(*OrderCancelParamGroup org),LONG
!    (   )           
OrderRevoke                     PROCEDURE(*OrderRevokeParamGroup org),LONG
!   
OrderStatus                     PROCEDURE(*OrderStatusParamGroup org),LONG

CheckAPIError                   PROCEDURE(BufferClass pCStr),BYTE
GetAPIError                     PROCEDURE(),STRING
CheckServerError                PROCEDURE(BufferClass pCStr),BYTE
GetServerError                  PROCEDURE(),STRING
SetTimeOut                      PROCEDURE(LONG inTimeOut=5)
GetGUID                         PROCEDURE(),STRING
GetRquid                        PROCEDURE(),STRING
Base64Encode                    PROCEDURE(STRING inStr),STRING
Message                         PROCEDURE(STRING inMessage)
FormatDate                      PROCEDURE(<LONG inDate>, <LONG inTime>, BYTE TimeOffset=FALSE), STRING
SaveToFile                      PROCEDURE(STRING inStr, STRING inFile)
ToUTF8                          PROCEDURE(STRING inStr), STRING    
GetQRImageFile                  PROCEDURE(STRING inUrl, <STRING inPath>), STRING    
                              END

_EndOfInclude_


